﻿using HeuristicLab.Clients.Hive.WebJobManager.Services;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using HeuristicLab.Clients.Hive.WebJobManager.Services;

namespace HeuristicLab.Clients.Hive.WebJobManager
{
    public class JobUpdaterHub : Hub
    {
        private RefreshableJob Job;

        public void initConnection()
        {
            Job = FileOpeningService.Instance.Job;
        }
        public void sendUpdate()
        {
            Clients.All.sendUpdate();
        }
        public void updateAll()
        {
            FileOpeningService.Instance.refreshJob();
            Job = FileOpeningService.Instance.Job;
            
            foreach (var t in Job.HiveTasks)
            {
                looperTasks(t);
            }
            Clients.All.requestDone();

        }
        private void looperTasks(HiveTask task)
        {
            try
            {
                JsonSerializerSettings settings = new JsonSerializerSettings();
                settings.ContractResolver = new JsonTaskResolver();
                var json = JsonConvert.SerializeObject(task.Task, settings);
                Clients.All.processData(task.Task.Id,json );
                foreach (var t in task.ChildHiveTasks)
                {
                    looperTasks(t);
                }
            }
            catch (JsonSerializationException e) { }
        }
    }
}
